import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { DynamicFormAction, DynamicFormElement } from '@dynamic-forms/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class MatDynamicFormDialogComponent implements OnInit, OnChanges, OnDestroy {
    private dialog;
    theme: string;
    private _dialog;
    private _dialogOpenSubscription;
    dialogTemplateRef: TemplateRef<any>;
    isOpen$: Observable<boolean>;
    children: DynamicFormElement[];
    headerActions: DynamicFormAction[];
    footerActions: DynamicFormAction[];
    width: string;
    height: string;
    minWidth: string;
    minHeight: string;
    maxWidth: string;
    maxHeight: string;
    maximized: boolean;
    title: string;
    titleHtml: string;
    classNameForm: string;
    classNameModal: string;
    classNameChildren: string;
    classNameHeader: string;
    classNameFooter: string;
    classNameTitle: string;
    escaped: EventEmitter<any>;
    constructor(dialog: MatDialog, theme: string);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private openDialog;
    private closeDialog;
    private getDialogConfig;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatDynamicFormDialogComponent, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatDynamicFormDialogComponent, "mat-dynamic-form-dialog", never, { "isOpen$": "isOpen$"; "children": "children"; "headerActions": "headerActions"; "footerActions": "footerActions"; "width": "width"; "height": "height"; "minWidth": "minWidth"; "minHeight": "minHeight"; "maxWidth": "maxWidth"; "maxHeight": "maxHeight"; "maximized": "maximized"; "title": "title"; "titleHtml": "titleHtml"; "classNameForm": "classNameForm"; "classNameModal": "classNameModal"; "classNameChildren": "classNameChildren"; "classNameHeader": "classNameHeader"; "classNameFooter": "classNameFooter"; "classNameTitle": "classNameTitle"; }, { "escaped": "escaped"; }, never, never, false>;
}
